=begin
#Platform external API.

#Documentation of our Platform external API.

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.34
=end

module Shippo
  class UserParcelTemplatesApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a new user parcel template
    # Creates a new user parcel template. You can choose to create a parcel template using a preset carrier template as a starting point, or you can create an entirely custom one. To use a preset carrier template, pass in a unique template token from [this list](https://goshippo.com/docs/reference#parcel-templates), plus the weight fields (**weight** and **weight_unit**). Otherwise, omit the template field and pass the other fields, for the weight, length, height, and depth, as well as their units.
    # @param [Hash] opts the optional parameters
    # @option opts [UserParcelTemplateRequestBodyWrapper] :body 
    # @return [UserParcelTemplateStruct]
    def create_user_parcel_template(opts = {})
      data, _status_code, _headers = create_user_parcel_template_with_http_info(opts)
      data
    end

    # Create a new user parcel template
    # Creates a new user parcel template. You can choose to create a parcel template using a preset carrier template as a starting point, or you can create an entirely custom one. To use a preset carrier template, pass in a unique template token from [this list](https://goshippo.com/docs/reference#parcel-templates), plus the weight fields (**weight** and **weight_unit**). Otherwise, omit the template field and pass the other fields, for the weight, length, height, and depth, as well as their units.
    # @param [Hash] opts the optional parameters
    # @option opts [UserParcelTemplateRequestBodyWrapper] :body 
    # @return [Array<(UserParcelTemplateStruct, Integer, Hash)>] UserParcelTemplateStruct data, response status code and response headers
    def create_user_parcel_template_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: UserParcelTemplatesApi.create_user_parcel_template ...'
      end
      # resource path
      local_var_path = '/merchants/{MerchantId}/user-parcel-templates/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(opts[:'body']) 

      return_type = opts[:return_type] || 'UserParcelTemplateStruct' 

      auth_names = opts[:auth_names] || ['APIKeyHeader']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UserParcelTemplatesApi#create_user_parcel_template\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Delete a user parcel template
    # Delete a user parcel template by object ID.
    # @param user_parcel_template_token The unique string representation of the user parcel template
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_user_parcel_template(user_parcel_template_token, opts = {})
      delete_user_parcel_template_with_http_info(user_parcel_template_token, opts)
      nil
    end

    # Delete a user parcel template
    # Delete a user parcel template by object ID.
    # @param user_parcel_template_token The unique string representation of the user parcel template
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def delete_user_parcel_template_with_http_info(user_parcel_template_token, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: UserParcelTemplatesApi.delete_user_parcel_template ...'
      end
      # verify the required parameter 'user_parcel_template_token' is set
      if @api_client.config.client_side_validation && user_parcel_template_token.nil?
        fail ArgumentError, "Missing the required parameter 'user_parcel_template_token' when calling UserParcelTemplatesApi.delete_user_parcel_template"
      end
      # resource path
      local_var_path = '/merchants/{MerchantId}/user-parcel-templates/{UserParcelTemplateObjectId}/'.sub('{' + 'UserParcelTemplateToken' + '}', user_parcel_template_token.to_s)

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] 

      auth_names = opts[:auth_names] || ['APIKeyHeader']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UserParcelTemplatesApi#delete_user_parcel_template\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List all user parcel templates
    # List all user parcel template objects.
    # @param [Hash] opts the optional parameters
    # @return [AllUserParcelTemplateResponse]
    def list_user_parcel_templates(opts = {})
      data, _status_code, _headers = list_user_parcel_templates_with_http_info(opts)
      data
    end

    # List all user parcel templates
    # List all user parcel template objects.
    # @param [Hash] opts the optional parameters
    # @return [Array<(AllUserParcelTemplateResponse, Integer, Hash)>] AllUserParcelTemplateResponse data, response status code and response headers
    def list_user_parcel_templates_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: UserParcelTemplatesApi.list_user_parcel_templates ...'
      end
      # resource path
      local_var_path = '/merchants/{MerchantId}/user-parcel-templates/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'AllUserParcelTemplateResponse' 

      auth_names = opts[:auth_names] || ['APIKeyHeader']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UserParcelTemplatesApi#list_user_parcel_templates\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Retrieves an user parcel templates
    # Fetches the parcel template information for a specific user parcel template, identified by the object ID.
    # @param user_parcel_template_token The unique string representation of the user parcel template
    # @param [Hash] opts the optional parameters
    # @return [UserParcelTemplateStruct]
    def get_user_parcel_template(user_parcel_template_token, opts = {})
      data, _status_code, _headers = get_user_parcel_template_with_http_info(user_parcel_template_token, opts)
      data
    end

    # Retrieves an user parcel templates
    # Fetches the parcel template information for a specific user parcel template, identified by the object ID.
    # @param user_parcel_template_token The unique string representation of the user parcel template
    # @param [Hash] opts the optional parameters
    # @return [Array<(UserParcelTemplateStruct, Integer, Hash)>] UserParcelTemplateStruct data, response status code and response headers
    def get_user_parcel_template_with_http_info(user_parcel_template_token, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: UserParcelTemplatesApi.get_user_parcel_template ...'
      end
      # verify the required parameter 'user_parcel_template_token' is set
      if @api_client.config.client_side_validation && user_parcel_template_token.nil?
        fail ArgumentError, "Missing the required parameter 'user_parcel_template_token' when calling UserParcelTemplatesApi.get_user_parcel_template"
      end
      # resource path
      local_var_path = '/merchants/{MerchantId}/user-parcel-templates/{UserParcelTemplateObjectId}/'.sub('{' + 'UserParcelTemplateToken' + '}', user_parcel_template_token.to_s)

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'UserParcelTemplateStruct' 

      auth_names = opts[:auth_names] || ['APIKeyHeader']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UserParcelTemplatesApi#get_user_parcel_template\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Update an existing user parcel template
    # Updates an existing user parcel template.
    # @param user_parcel_template_token The unique string representation of the user parcel template
    # @param [Hash] opts the optional parameters
    # @option opts [UserParcelTemplateRequestBodyWrapper] :body Address details.
    # @return [UserParcelTemplateStruct]
    def update_user_parcel_template(user_parcel_template_token, opts = {})
      data, _status_code, _headers = update_user_parcel_template_with_http_info(user_parcel_template_token, opts)
      data
    end

    # Update an existing user parcel template
    # Updates an existing user parcel template.
    # @param user_parcel_template_token The unique string representation of the user parcel template
    # @param [Hash] opts the optional parameters
    # @option opts [UserParcelTemplateRequestBodyWrapper] :body Address details.
    # @return [Array<(UserParcelTemplateStruct, Integer, Hash)>] UserParcelTemplateStruct data, response status code and response headers
    def update_user_parcel_template_with_http_info(user_parcel_template_token, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: UserParcelTemplatesApi.update_user_parcel_template ...'
      end
      # verify the required parameter 'user_parcel_template_token' is set
      if @api_client.config.client_side_validation && user_parcel_template_token.nil?
        fail ArgumentError, "Missing the required parameter 'user_parcel_template_token' when calling UserParcelTemplatesApi.update_user_parcel_template"
      end
      # resource path
      local_var_path = '/merchants/{MerchantId}/user-parcel-templates/{UserParcelTemplateObjectId}'.sub('{' + 'UserParcelTemplateToken' + '}', user_parcel_template_token.to_s)

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(opts[:'body']) 

      return_type = opts[:return_type] || 'UserParcelTemplateStruct' 

      auth_names = opts[:auth_names] || ['APIKeyHeader']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UserParcelTemplatesApi#update_user_parcel_template\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
